package de.killig;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;

import de.killig.math.InverseDistanceSquared;
import de.killig.math.Point2_5D;

public class DataCanvas extends Canvas {
	Point2_5D[] points;
	Rectangle2D r;
	//int n;
	int width,height;
	BufferedImage i;

	public DataCanvas(Point2_5D[] points, Rectangle2D r/*, int n*/) {
		this.points=points;
		this.r=r;
		//this.n=n;
	}
	
	public void paint(Graphics g) {
		double v;
		System.out.println("paint(); getWidth()="+getWidth()+"; getHeight()="+getHeight());
		if(getWidth()!=width || getHeight()!=height) {
			width=getWidth();
			height=getHeight();
			i=new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);
			long time;
			time=System.currentTimeMillis();
			double[][] d=InverseDistanceSquared.calc(points, r, width, height/*, n*/);
			System.out.println(System.currentTimeMillis()-time);
			time=System.currentTimeMillis();
			for(int y=0;y<height;y++) {
				for(int x=0;x<width;x++) {
					//v=d[x][y];
					v=(-InverseDistanceSquared.min+d[x][y])/(InverseDistanceSquared.max-InverseDistanceSquared.min);
					i.setRGB(x,height-1-y,Color.HSBtoRGB((float)v,1f,1f));
					//i.setRGB(x,height-1-y,Color.HSBtoRGB(0f,0f,(float)v));
				}
			}
			System.out.println(System.currentTimeMillis()-time);
		}
		g.drawImage(i,0,0,null);
	}

}
